#pragma once

/*! \mainpage CGP Code Documentation
 *
 * # Introduction
 *
 * cgp - Visual Computing Library - is a simple lightweight library on top of OpenGL provided to ease learning of 3D programming while avoiding re-coding everything from scratch (matrices, mesh structures, etc.). The library provides several helper structure and functions to set up 3D scene with interactive and/or animated elements.
 *
 * The objective of the library is to be simple as simple as possible to read and use. The majority of cgp structures and functions are aimed to be minimalistic without hidden states. The code remains fully compatible with direct raw OpenGL calls and user-defined shaders. The animation loop itself is entirely defined by the user.
 *
 * 
 *
 */


#include "cgp_parameters.hpp"
#include "core/core.hpp"
#include "geometry/geometry.hpp"
#include "graphics/graphics.hpp"

